diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/js/jquery/jquery.form.js /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/js/jquery/jquery.form.js
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/js/jquery/jquery.form.js	2012-08-22 19:04:18.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/js/jquery/jquery.form.js	2013-09-16 16:06:09.000000000 -0500
***************
*** 1,469 ****
  /*!
   * jQuery Form Plugin
!  * version: 2.73 (03-MAY-2011)
!  * @requires jQuery v1.3.2 or later
!  *
   * Examples and documentation at: http://malsup.com/jquery/form/
!  * Dual licensed under the MIT and GPL licenses:
!  *   http://www.opensource.org/licenses/mit-license.php
!  *   http://www.gnu.org/licenses/gpl.html
   */
  ;(function($) {
  
  /*
! 	Usage Note:
! 	-----------
! 	Do not use both ajaxSubmit and ajaxForm on the same form.  These
! 	functions are intended to be exclusive.  Use ajaxSubmit if you want
! 	to bind your own submit handler to the form.  For example,
! 
! 	$(document).ready(function() {
! 		$('#myForm').bind('submit', function(e) {
! 			e.preventDefault(); // <-- important
! 			$(this).ajaxSubmit({
! 				target: '#output'
! 			});
! 		});
! 	});
! 
! 	Use ajaxForm when you want the plugin to manage all the event binding
! 	for you.  For example,
! 
! 	$(document).ready(function() {
! 		$('#myForm').ajaxForm({
! 			target: '#output'
! 		});
! 	});
  
! 	When using ajaxForm, the ajaxSubmit function will be invoked for you
! 	at the appropriate time.
  */
  
  /**
   * ajaxSubmit() provides a mechanism for immediately submitting
   * an HTML form using AJAX.
   */
  $.fn.ajaxSubmit = function(options) {
! 	// fast fail if nothing selected (http://dev.jquery.com/ticket/2752)
! 	if (!this.length) {
! 		log('ajaxSubmit: skipping submit process - no element selected');
! 		return this;
! 	}
! 
! 	if (typeof options == 'function') {
! 		options = { success: options };
! 	}
! 
! 	var action = this.attr('action');
! 	var url = (typeof action === 'string') ? $.trim(action) : '';
! 	if (url) {
! 		// clean url (don't include hash vaue)
! 		url = (url.match(/^([^#]+)/)||[])[1];
! 	}
! 	url = url || window.location.href || '';
! 
! 	options = $.extend(true, {
! 		url:  url,
! 		success: $.ajaxSettings.success,
! 		type: this[0].getAttribute('method') || 'GET', // IE7 massage (see issue 57)
! 		iframeSrc: /^https/i.test(window.location.href || '') ? 'javascript:false' : 'about:blank'
! 	}, options);
! 
! 	// hook for manipulating the form data before it is extracted;
! 	// convenient for use with rich editors like tinyMCE or FCKEditor
! 	var veto = {};
! 	this.trigger('form-pre-serialize', [this, options, veto]);
! 	if (veto.veto) {
! 		log('ajaxSubmit: submit vetoed via form-pre-serialize trigger');
! 		return this;
! 	}
! 
! 	// provide opportunity to alter form data before it is serialized
! 	if (options.beforeSerialize && options.beforeSerialize(this, options) === false) {
! 		log('ajaxSubmit: submit aborted via beforeSerialize callback');
! 		return this;
! 	}
! 
! 	var n,v,a = this.formToArray(options.semantic);
! 	if (options.data) {
! 		options.extraData = options.data;
! 		for (n in options.data) {
! 			if(options.data[n] instanceof Array) {
! 				for (var k in options.data[n]) {
! 					a.push( { name: n, value: options.data[n][k] } );
! 				}
! 			}
! 			else {
! 				v = options.data[n];
! 				v = $.isFunction(v) ? v() : v; // if value is fn, invoke it
! 				a.push( { name: n, value: v } );
! 			}
! 		}
! 	}
! 
! 	// give pre-submit callback an opportunity to abort the submit
! 	if (options.beforeSubmit && options.beforeSubmit(a, this, options) === false) {
! 		log('ajaxSubmit: submit aborted via beforeSubmit callback');
! 		return this;
! 	}
! 
! 	// fire vetoable 'validate' event
! 	this.trigger('form-submit-validate', [a, this, options, veto]);
! 	if (veto.veto) {
! 		log('ajaxSubmit: submit vetoed via form-submit-validate trigger');
! 		return this;
! 	}
! 
! 	var q = $.param(a);
! 
! 	if (options.type.toUpperCase() == 'GET') {
! 		options.url += (options.url.indexOf('?') >= 0 ? '&' : '?') + q;
! 		options.data = null;  // data is null for 'get'
! 	}
! 	else {
! 		options.data = q; // data is the query string for 'post'
! 	}
! 
! 	var $form = this, callbacks = [];
! 	if (options.resetForm) {
! 		callbacks.push(function() { $form.resetForm(); });
! 	}
! 	if (options.clearForm) {
! 		callbacks.push(function() { $form.clearForm(); });
! 	}
! 
! 	// perform a load on the target only if dataType is not provided
! 	if (!options.dataType && options.target) {
! 		var oldSuccess = options.success || function(){};
! 		callbacks.push(function(data) {
! 			var fn = options.replaceTarget ? 'replaceWith' : 'html';
! 			$(options.target)[fn](data).each(oldSuccess, arguments);
! 		});
! 	}
! 	else if (options.success) {
! 		callbacks.push(options.success);
! 	}
! 
! 	options.success = function(data, status, xhr) { // jQuery 1.4+ passes xhr as 3rd arg
! 		var context = options.context || options;   // jQuery 1.4+ supports scope context
! 		for (var i=0, max=callbacks.length; i < max; i++) {
! 			callbacks[i].apply(context, [data, status, xhr || $form, $form]);
! 		}
! 	};
! 
! 	// are there files to upload?
! 	var fileInputs = $('input:file', this).length > 0;
! 	var mp = 'multipart/form-data';
! 	var multipart = ($form.attr('enctype') == mp || $form.attr('encoding') == mp);
! 
! 	// options.iframe allows user to force iframe mode
! 	// 06-NOV-09: now defaulting to iframe mode if file input is detected
!    if (options.iframe !== false && (fileInputs || options.iframe || multipart)) {
! 	   // hack to fix Safari hang (thanks to Tim Molendijk for this)
! 	   // see:  http://groups.google.com/group/jquery-dev/browse_thread/thread/36395b7ab510dd5d
! 	   if (options.closeKeepAlive) {
! 		   $.get(options.closeKeepAlive, fileUpload);
! 		}
! 	   else {
! 		   fileUpload();
! 		}
!    }
!    else {
! 		$.ajax(options);
!    }
! 
! 	// fire 'notify' event
! 	this.trigger('form-submit-notify', [this, options]);
! 	return this;
! 
! 
! 	// private function for handling file uploads (hat tip to YAHOO!)
! 	function fileUpload() {
! 		var form = $form[0];
! 
! 		if ($(':input[name=submit],:input[id=submit]', form).length) {
! 			// if there is an input with a name or id of 'submit' then we won't be
! 			// able to invoke the submit fn on the form (at least not x-browser)
! 			alert('Error: Form elements must not have name or id of "submit".');
! 			return;
! 		}
! 
! 		var s = $.extend(true, {}, $.ajaxSettings, options);
! 		s.context = s.context || s;
! 		var id = 'jqFormIO' + (new Date().getTime()), fn = '_'+id;
! 		var $io = $('<iframe id="' + id + '" name="' + id + '" src="'+ s.iframeSrc +'" />');
! 		var io = $io[0];
! 
! 		$io.css({ position: 'absolute', top: '-1000px', left: '-1000px' });
! 
! 		var xhr = { // mock object
! 			aborted: 0,
! 			responseText: null,
! 			responseXML: null,
! 			status: 0,
! 			statusText: 'n/a',
! 			getAllResponseHeaders: function() {},
! 			getResponseHeader: function() {},
! 			setRequestHeader: function() {},
! 			abort: function(status) {
! 				var e = (status === 'timeout' ? 'timeout' : 'aborted');
! 				log('aborting upload... ' + e);
! 				this.aborted = 1;
! 				$io.attr('src', s.iframeSrc); // abort op in progress
! 				xhr.error = e;
! 				s.error && s.error.call(s.context, xhr, e, e);
! 				g && $.event.trigger("ajaxError", [xhr, s, e]);
! 				s.complete && s.complete.call(s.context, xhr, e);
! 			}
! 		};
! 
! 		var g = s.global;
! 		// trigger ajax global events so that activity/block indicators work like normal
! 		if (g && ! $.active++) {
! 			$.event.trigger("ajaxStart");
! 		}
! 		if (g) {
! 			$.event.trigger("ajaxSend", [xhr, s]);
! 		}
! 
! 		if (s.beforeSend && s.beforeSend.call(s.context, xhr, s) === false) {
! 			if (s.global) {
! 				$.active--;
! 			}
! 			return;
! 		}
! 		if (xhr.aborted) {
! 			return;
! 		}
! 
! 		var timedOut = 0, timeoutHandle;
! 
! 		// add submitting element to data if we know it
! 		var sub = form.clk;
! 		if (sub) {
! 			var n = sub.name;
! 			if (n && !sub.disabled) {
! 				s.extraData = s.extraData || {};
! 				s.extraData[n] = sub.value;
! 				if (sub.type == "image") {
! 					s.extraData[n+'.x'] = form.clk_x;
! 					s.extraData[n+'.y'] = form.clk_y;
! 				}
! 			}
! 		}
! 
! 		// take a breath so that pending repaints get some cpu time before the upload starts
! 		function doSubmit() {
! 			// make sure form attrs are set
! 			var t = $form.attr('target'), a = $form.attr('action');
! 
! 			// update form attrs in IE friendly way
! 			form.setAttribute('target',id);
! 			if (form.getAttribute('method') != 'POST') {
! 				form.setAttribute('method', 'POST');
! 			}
! 			if (form.getAttribute('action') != s.url) {
! 				form.setAttribute('action', s.url);
! 			}
! 
! 			// ie borks in some cases when setting encoding
! 			if (! s.skipEncodingOverride) {
! 				$form.attr({
! 					encoding: 'multipart/form-data',
! 					enctype:  'multipart/form-data'
! 				});
! 			}
! 
! 			// support timout
! 			if (s.timeout) {
! 				timeoutHandle = setTimeout(function() { timedOut = true; cb(true); }, s.timeout);
! 			}
! 
! 			// add "extra" data to form if provided in options
! 			var extraInputs = [];
! 			try {
! 				if (s.extraData) {
! 					for (var n in s.extraData) {
! 						extraInputs.push(
! 							$('<input type="hidden" name="'+n+'" value="'+s.extraData[n]+'" />')
! 								.appendTo(form)[0]);
! 					}
! 				}
! 
! 				// add iframe to doc and submit the form
! 				$io.appendTo('body');
!                 io.attachEvent ? io.attachEvent('onload', cb) : io.addEventListener('load', cb, false);
! 				form.submit();
! 			}
! 			finally {
! 				// reset attrs and remove "extra" input elements
! 				form.setAttribute('action',a);
! 				if(t) {
! 					form.setAttribute('target', t);
! 				} else {
! 					$form.removeAttr('target');
! 				}
! 				$(extraInputs).remove();
! 			}
! 		}
! 
! 		if (s.forceSync) {
! 			doSubmit();
! 		}
! 		else {
! 			setTimeout(doSubmit, 10); // this lets dom updates render
! 		}
! 
! 		var data, doc, domCheckCount = 50, callbackProcessed;
! 
! 		function cb(e) {
! 			if (xhr.aborted || callbackProcessed) {
! 				return;
! 			}
! 			if (e === true && xhr) {
! 				xhr.abort('timeout');
! 				return;
! 			}
! 
! 			var doc = io.contentWindow ? io.contentWindow.document : io.contentDocument ? io.contentDocument : io.document;
! 			if (!doc || doc.location.href == s.iframeSrc) {
! 				// response not received yet
! 				if (!timedOut)
! 					return;
! 			}
!             io.detachEvent ? io.detachEvent('onload', cb) : io.removeEventListener('load', cb, false);
! 
! 			var ok = true;
! 			try {
! 				if (timedOut) {
! 					throw 'timeout';
! 				}
! 
! 				var isXml = s.dataType == 'xml' || doc.XMLDocument || $.isXMLDoc(doc);
! 				log('isXml='+isXml);
! 				if (!isXml && window.opera && (doc.body == null || doc.body.innerHTML == '')) {
! 					if (--domCheckCount) {
! 						// in some browsers (Opera) the iframe DOM is not always traversable when
! 						// the onload callback fires, so we loop a bit to accommodate
! 						log('requeing onLoad callback, DOM not available');
! 						setTimeout(cb, 250);
! 						return;
! 					}
! 					// let this fall through because server response could be an empty document
! 					//log('Could not access iframe DOM after mutiple tries.');
! 					//throw 'DOMException: not available';
! 				}
! 
! 				//log('response detected');
! 				xhr.responseText = doc.body ? doc.body.innerHTML : doc.documentElement ? doc.documentElement.innerHTML : null;
! 				xhr.responseXML = doc.XMLDocument ? doc.XMLDocument : doc;
! 				if (isXml)
! 					s.dataType = 'xml';
! 				xhr.getResponseHeader = function(header){
! 					var headers = {'content-type': s.dataType};
! 					return headers[header];
! 				};
! 
! 				var scr = /(json|script|text)/.test(s.dataType);
! 				if (scr || s.textarea) {
! 					// see if user embedded response in textarea
! 					var ta = doc.getElementsByTagName('textarea')[0];
! 					if (ta) {
! 						xhr.responseText = ta.value;
! 					}
! 					else if (scr) {
! 						// account for browsers injecting pre around json response
! 						var pre = doc.getElementsByTagName('pre')[0];
! 						var b = doc.getElementsByTagName('body')[0];
! 						if (pre) {
! 							xhr.responseText = pre.textContent;
! 						}
! 						else if (b) {
! 							xhr.responseText = b.innerHTML;
! 						}
! 					}
! 				}
! 				else if (s.dataType == 'xml' && !xhr.responseXML && xhr.responseText != null) {
! 					xhr.responseXML = toXml(xhr.responseText);
! 				}
! 
! 				data = httpData(xhr, s.dataType, s);
! 			}
! 			catch(e){
! 				log('error caught:',e);
! 				ok = false;
! 				xhr.error = e;
! 				s.error && s.error.call(s.context, xhr, 'error', e);
! 				g && $.event.trigger("ajaxError", [xhr, s, e]);
! 			}
! 
! 			if (xhr.aborted) {
! 				log('upload aborted');
! 				ok = false;
! 			}
  
! 			// ordering of these callbacks/triggers is odd, but that's how $.ajax does it
! 			if (ok) {
! 				s.success && s.success.call(s.context, data, 'success', xhr);
! 				g && $.event.trigger("ajaxSuccess", [xhr, s]);
! 			}
! 
! 			g && $.event.trigger("ajaxComplete", [xhr, s]);
! 
! 			if (g && ! --$.active) {
! 				$.event.trigger("ajaxStop");
! 			}
! 
! 			s.complete && s.complete.call(s.context, xhr, ok ? 'success' : 'error');
! 
! 			callbackProcessed = true;
! 			if (s.timeout)
! 				clearTimeout(timeoutHandle);
! 
! 			// clean up
! 			setTimeout(function() {
! 				$io.removeData('form-plugin-onload');
! 				$io.remove();
! 				xhr.responseXML = null;
! 			}, 100);
! 		}
  
! 		var toXml = $.parseXML || function(s, doc) { // use parseXML if available (jQuery 1.5+)
! 			if (window.ActiveXObject) {
! 				doc = new ActiveXObject('Microsoft.XMLDOM');
! 				doc.async = 'false';
! 				doc.loadXML(s);
! 			}
! 			else {
! 				doc = (new DOMParser()).parseFromString(s, 'text/xml');
! 			}
! 			return (doc && doc.documentElement && doc.documentElement.nodeName != 'parsererror') ? doc : null;
! 		};
! 		var parseJSON = $.parseJSON || function(s) {
! 			return window['eval']('(' + s + ')');
! 		};
! 
! 		var httpData = function( xhr, type, s ) { // mostly lifted from jq1.4.4
! 			var ct = xhr.getResponseHeader('content-type') || '',
! 				xml = type === 'xml' || !type && ct.indexOf('xml') >= 0,
! 				data = xml ? xhr.responseXML : xhr.responseText;
! 
! 			if (xml && data.documentElement.nodeName === 'parsererror') {
! 				$.error && $.error('parsererror');
! 			}
! 			if (s && s.dataFilter) {
! 				data = s.dataFilter(data, type);
! 			}
! 			if (typeof data === 'string') {
! 				if (type === 'json' || !type && ct.indexOf('json') >= 0) {
! 					data = parseJSON(data);
! 				} else if (type === "script" || !type && ct.indexOf("javascript") >= 0) {
! 					$.globalEval(data);
! 				}
! 			}
! 			return data;
! 		};
! 	}
  };
  
  /**
--- 1,774 ----
  /*!
   * jQuery Form Plugin
!  * version: 3.37.0-2013.07.11
!  * @requires jQuery v1.5 or later
!  * Copyright (c) 2013 M. Alsup
   * Examples and documentation at: http://malsup.com/jquery/form/
!  * Project repository: https://github.com/malsup/form
!  * Dual licensed under the MIT and GPL licenses.
!  * https://github.com/malsup/form#copyright-and-license
   */
+ /*global ActiveXObject */
  ;(function($) {
+ "use strict";
  
  /*
!     Usage Note:
!     -----------
!     Do not use both ajaxSubmit and ajaxForm on the same form.  These
!     functions are mutually exclusive.  Use ajaxSubmit if you want
!     to bind your own submit handler to the form.  For example,
! 
!     $(document).ready(function() {
!         $('#myForm').on('submit', function(e) {
!             e.preventDefault(); // <-- important
!             $(this).ajaxSubmit({
!                 target: '#output'
!             });
!         });
!     });
! 
!     Use ajaxForm when you want the plugin to manage all the event binding
!     for you.  For example,
! 
!     $(document).ready(function() {
!         $('#myForm').ajaxForm({
!             target: '#output'
!         });
!     });
! 
!     You can also use ajaxForm with delegation (requires jQuery v1.7+), so the
!     form does not have to exist when you invoke ajaxForm:
! 
!     $('#myForm').ajaxForm({
!         delegation: true,
!         target: '#output'
!     });
  
!     When using ajaxForm, the ajaxSubmit function will be invoked for you
!     at the appropriate time.
  */
  
  /**
+  * Feature detection
+  */
+ var feature = {};
+ feature.fileapi = $("<input type='file'/>").get(0).files !== undefined;
+ feature.formdata = window.FormData !== undefined;
+ 
+ var hasProp = !!$.fn.prop;
+ 
+ // attr2 uses prop when it can but checks the return type for
+ // an expected string.  this accounts for the case where a form 
+ // contains inputs with names like "action" or "method"; in those
+ // cases "prop" returns the element
+ $.fn.attr2 = function() {
+     if ( ! hasProp )
+         return this.attr.apply(this, arguments);
+     var val = this.prop.apply(this, arguments);
+     if ( ( val && val.jquery ) || typeof val === 'string' )
+         return val;
+     return this.attr.apply(this, arguments);
+ };
+ 
+ /**
   * ajaxSubmit() provides a mechanism for immediately submitting
   * an HTML form using AJAX.
   */
  $.fn.ajaxSubmit = function(options) {
!     /*jshint scripturl:true */
  
!     // fast fail if nothing selected (http://dev.jquery.com/ticket/2752)
!     if (!this.length) {
!         log('ajaxSubmit: skipping submit process - no element selected');
!         return this;
!     }
! 
!     var method, action, url, $form = this;
! 
!     if (typeof options == 'function') {
!         options = { success: options };
!     }
!     else if ( options === undefined ) {
!         options = {};
!     }
! 
!     method = options.type || this.attr2('method');
!     action = options.url  || this.attr2('action');
! 
!     url = (typeof action === 'string') ? $.trim(action) : '';
!     url = url || window.location.href || '';
!     if (url) {
!         // clean url (don't include hash vaue)
!         url = (url.match(/^([^#]+)/)||[])[1];
!     }
! 
!     options = $.extend(true, {
!         url:  url,
!         success: $.ajaxSettings.success,
!         type: method || 'GET',
!         iframeSrc: /^https/i.test(window.location.href || '') ? 'javascript:false' : 'about:blank'
!     }, options);
! 
!     // hook for manipulating the form data before it is extracted;
!     // convenient for use with rich editors like tinyMCE or FCKEditor
!     var veto = {};
!     this.trigger('form-pre-serialize', [this, options, veto]);
!     if (veto.veto) {
!         log('ajaxSubmit: submit vetoed via form-pre-serialize trigger');
!         return this;
!     }
! 
!     // provide opportunity to alter form data before it is serialized
!     if (options.beforeSerialize && options.beforeSerialize(this, options) === false) {
!         log('ajaxSubmit: submit aborted via beforeSerialize callback');
!         return this;
!     }
! 
!     var traditional = options.traditional;
!     if ( traditional === undefined ) {
!         traditional = $.ajaxSettings.traditional;
!     }
! 
!     var elements = [];
!     var qx, a = this.formToArray(options.semantic, elements);
!     if (options.data) {
!         options.extraData = options.data;
!         qx = $.param(options.data, traditional);
!     }
! 
!     // give pre-submit callback an opportunity to abort the submit
!     if (options.beforeSubmit && options.beforeSubmit(a, this, options) === false) {
!         log('ajaxSubmit: submit aborted via beforeSubmit callback');
!         return this;
!     }
! 
!     // fire vetoable 'validate' event
!     this.trigger('form-submit-validate', [a, this, options, veto]);
!     if (veto.veto) {
!         log('ajaxSubmit: submit vetoed via form-submit-validate trigger');
!         return this;
!     }
! 
!     var q = $.param(a, traditional);
!     if (qx) {
!         q = ( q ? (q + '&' + qx) : qx );
!     }
!     if (options.type.toUpperCase() == 'GET') {
!         options.url += (options.url.indexOf('?') >= 0 ? '&' : '?') + q;
!         options.data = null;  // data is null for 'get'
!     }
!     else {
!         options.data = q; // data is the query string for 'post'
!     }
! 
!     var callbacks = [];
!     if (options.resetForm) {
!         callbacks.push(function() { $form.resetForm(); });
!     }
!     if (options.clearForm) {
!         callbacks.push(function() { $form.clearForm(options.includeHidden); });
!     }
! 
!     // perform a load on the target only if dataType is not provided
!     if (!options.dataType && options.target) {
!         var oldSuccess = options.success || function(){};
!         callbacks.push(function(data) {
!             var fn = options.replaceTarget ? 'replaceWith' : 'html';
!             $(options.target)[fn](data).each(oldSuccess, arguments);
!         });
!     }
!     else if (options.success) {
!         callbacks.push(options.success);
!     }
! 
!     options.success = function(data, status, xhr) { // jQuery 1.4+ passes xhr as 3rd arg
!         var context = options.context || this ;    // jQuery 1.4+ supports scope context
!         for (var i=0, max=callbacks.length; i < max; i++) {
!             callbacks[i].apply(context, [data, status, xhr || $form, $form]);
!         }
!     };
! 
!     if (options.error) {
!         var oldError = options.error;
!         options.error = function(xhr, status, error) {
!             var context = options.context || this;
!             oldError.apply(context, [xhr, status, error, $form]);
!         };
!     }
! 
!      if (options.complete) {
!         var oldComplete = options.complete;
!         options.complete = function(xhr, status) {
!             var context = options.context || this;
!             oldComplete.apply(context, [xhr, status, $form]);
!         };
!     }
! 
!     // are there files to upload?
! 
!     // [value] (issue #113), also see comment:
!     // https://github.com/malsup/form/commit/588306aedba1de01388032d5f42a60159eea9228#commitcomment-2180219
!     var fileInputs = $('input[type=file]:enabled[value!=""]', this);
! 
!     var hasFileInputs = fileInputs.length > 0;
!     var mp = 'multipart/form-data';
!     var multipart = ($form.attr('enctype') == mp || $form.attr('encoding') == mp);
! 
!     var fileAPI = feature.fileapi && feature.formdata;
!     log("fileAPI :" + fileAPI);
!     var shouldUseFrame = (hasFileInputs || multipart) && !fileAPI;
! 
!     var jqxhr;
! 
!     // options.iframe allows user to force iframe mode
!     // 06-NOV-09: now defaulting to iframe mode if file input is detected
!     if (options.iframe !== false && (options.iframe || shouldUseFrame)) {
!         // hack to fix Safari hang (thanks to Tim Molendijk for this)
!         // see:  http://groups.google.com/group/jquery-dev/browse_thread/thread/36395b7ab510dd5d
!         if (options.closeKeepAlive) {
!             $.get(options.closeKeepAlive, function() {
!                 jqxhr = fileUploadIframe(a);
!             });
!         }
!         else {
!             jqxhr = fileUploadIframe(a);
!         }
!     }
!     else if ((hasFileInputs || multipart) && fileAPI) {
!         jqxhr = fileUploadXhr(a);
!     }
!     else {
!         jqxhr = $.ajax(options);
!     }
! 
!     $form.removeData('jqxhr').data('jqxhr', jqxhr);
! 
!     // clear element array
!     for (var k=0; k < elements.length; k++)
!         elements[k] = null;
! 
!     // fire 'notify' event
!     this.trigger('form-submit-notify', [this, options]);
!     return this;
! 
!     // utility fn for deep serialization
!     function deepSerialize(extraData){
!         var serialized = $.param(extraData, options.traditional).split('&');
!         var len = serialized.length;
!         var result = [];
!         var i, part;
!         for (i=0; i < len; i++) {
!             // #252; undo param space replacement
!             serialized[i] = serialized[i].replace(/\+/g,' ');
!             part = serialized[i].split('=');
!             // #278; use array instead of object storage, favoring array serializations
!             result.push([decodeURIComponent(part[0]), decodeURIComponent(part[1])]);
!         }
!         return result;
!     }
! 
!      // XMLHttpRequest Level 2 file uploads (big hat tip to francois2metz)
!     function fileUploadXhr(a) {
!         var formdata = new FormData();
! 
!         for (var i=0; i < a.length; i++) {
!             formdata.append(a[i].name, a[i].value);
!         }
! 
!         if (options.extraData) {
!             var serializedData = deepSerialize(options.extraData);
!             for (i=0; i < serializedData.length; i++)
!                 if (serializedData[i])
!                     formdata.append(serializedData[i][0], serializedData[i][1]);
!         }
! 
!         options.data = null;
! 
!         var s = $.extend(true, {}, $.ajaxSettings, options, {
!             contentType: false,
!             processData: false,
!             cache: false,
!             type: method || 'POST'
!         });
! 
!         if (options.uploadProgress) {
!             // workaround because jqXHR does not expose upload property
!             s.xhr = function() {
!                 var xhr = $.ajaxSettings.xhr();
!                 if (xhr.upload) {
!                     xhr.upload.addEventListener('progress', function(event) {
!                         var percent = 0;
!                         var position = event.loaded || event.position; /*event.position is deprecated*/
!                         var total = event.total;
!                         if (event.lengthComputable) {
!                             percent = Math.ceil(position / total * 100);
!                         }
!                         options.uploadProgress(event, position, total, percent);
!                     }, false);
!                 }
!                 return xhr;
!             };
!         }
! 
!         s.data = null;
!             var beforeSend = s.beforeSend;
!             s.beforeSend = function(xhr, o) {
!                 o.data = formdata;
!                 if(beforeSend)
!                     beforeSend.call(this, xhr, o);
!         };
!         return $.ajax(s);
!     }
! 
!     // private function for handling file uploads (hat tip to YAHOO!)
!     function fileUploadIframe(a) {
!         var form = $form[0], el, i, s, g, id, $io, io, xhr, sub, n, timedOut, timeoutHandle;
!         var deferred = $.Deferred();
! 
!         if (a) {
!             // ensure that every serialized input is still enabled
!             for (i=0; i < elements.length; i++) {
!                 el = $(elements[i]);
!                 if ( hasProp )
!                     el.prop('disabled', false);
!                 else
!                     el.removeAttr('disabled');
!             }
!         }
! 
!         s = $.extend(true, {}, $.ajaxSettings, options);
!         s.context = s.context || s;
!         id = 'jqFormIO' + (new Date().getTime());
!         if (s.iframeTarget) {
!             $io = $(s.iframeTarget);
!             n = $io.attr2('name');
!             if (!n)
!                  $io.attr2('name', id);
!             else
!                 id = n;
!         }
!         else {
!             $io = $('<iframe name="' + id + '" src="'+ s.iframeSrc +'" />');
!             $io.css({ position: 'absolute', top: '-1000px', left: '-1000px' });
!         }
!         io = $io[0];
! 
! 
!         xhr = { // mock object
!             aborted: 0,
!             responseText: null,
!             responseXML: null,
!             status: 0,
!             statusText: 'n/a',
!             getAllResponseHeaders: function() {},
!             getResponseHeader: function() {},
!             setRequestHeader: function() {},
!             abort: function(status) {
!                 var e = (status === 'timeout' ? 'timeout' : 'aborted');
!                 log('aborting upload... ' + e);
!                 this.aborted = 1;
! 
!                 try { // #214, #257
!                     if (io.contentWindow.document.execCommand) {
!                         io.contentWindow.document.execCommand('Stop');
!                     }
!                 }
!                 catch(ignore) {}
! 
!                 $io.attr('src', s.iframeSrc); // abort op in progress
!                 xhr.error = e;
!                 if (s.error)
!                     s.error.call(s.context, xhr, e, status);
!                 if (g)
!                     $.event.trigger("ajaxError", [xhr, s, e]);
!                 if (s.complete)
!                     s.complete.call(s.context, xhr, e);
!             }
!         };
! 
!         g = s.global;
!         // trigger ajax global events so that activity/block indicators work like normal
!         if (g && 0 === $.active++) {
!             $.event.trigger("ajaxStart");
!         }
!         if (g) {
!             $.event.trigger("ajaxSend", [xhr, s]);
!         }
! 
!         if (s.beforeSend && s.beforeSend.call(s.context, xhr, s) === false) {
!             if (s.global) {
!                 $.active--;
!             }
!             deferred.reject();
!             return deferred;
!         }
!         if (xhr.aborted) {
!             deferred.reject();
!             return deferred;
!         }
! 
!         // add submitting element to data if we know it
!         sub = form.clk;
!         if (sub) {
!             n = sub.name;
!             if (n && !sub.disabled) {
!                 s.extraData = s.extraData || {};
!                 s.extraData[n] = sub.value;
!                 if (sub.type == "image") {
!                     s.extraData[n+'.x'] = form.clk_x;
!                     s.extraData[n+'.y'] = form.clk_y;
!                 }
!             }
!         }
! 
!         var CLIENT_TIMEOUT_ABORT = 1;
!         var SERVER_ABORT = 2;
!                 
!         function getDoc(frame) {
!             /* it looks like contentWindow or contentDocument do not
!              * carry the protocol property in ie8, when running under ssl
!              * frame.document is the only valid response document, since
!              * the protocol is know but not on the other two objects. strange?
!              * "Same origin policy" http://en.wikipedia.org/wiki/Same_origin_policy
!              */
!             
!             var doc = null;
!             
!             // IE8 cascading access check
!             try {
!                 if (frame.contentWindow) {
!                     doc = frame.contentWindow.document;
!                 }
!             } catch(err) {
!                 // IE8 access denied under ssl & missing protocol
!                 log('cannot get iframe.contentWindow document: ' + err);
!             }
! 
!             if (doc) { // successful getting content
!                 return doc;
!             }
! 
!             try { // simply checking may throw in ie8 under ssl or mismatched protocol
!                 doc = frame.contentDocument ? frame.contentDocument : frame.document;
!             } catch(err) {
!                 // last attempt
!                 log('cannot get iframe.contentDocument: ' + err);
!                 doc = frame.document;
!             }
!             return doc;
!         }
! 
!         // Rails CSRF hack (thanks to Yvan Barthelemy)
!         var csrf_token = $('meta[name=csrf-token]').attr('content');
!         var csrf_param = $('meta[name=csrf-param]').attr('content');
!         if (csrf_param && csrf_token) {
!             s.extraData = s.extraData || {};
!             s.extraData[csrf_param] = csrf_token;
!         }
! 
!         // take a breath so that pending repaints get some cpu time before the upload starts
!         function doSubmit() {
!             // make sure form attrs are set
!             var t = $form.attr2('target'), a = $form.attr2('action');
! 
!             // update form attrs in IE friendly way
!             form.setAttribute('target',id);
!             if (!method) {
!                 form.setAttribute('method', 'POST');
!             }
!             if (a != s.url) {
!                 form.setAttribute('action', s.url);
!             }
! 
!             // ie borks in some cases when setting encoding
!             if (! s.skipEncodingOverride && (!method || /post/i.test(method))) {
!                 $form.attr({
!                     encoding: 'multipart/form-data',
!                     enctype:  'multipart/form-data'
!                 });
!             }
! 
!             // support timout
!             if (s.timeout) {
!                 timeoutHandle = setTimeout(function() { timedOut = true; cb(CLIENT_TIMEOUT_ABORT); }, s.timeout);
!             }
! 
!             // look for server aborts
!             function checkState() {
!                 try {
!                     var state = getDoc(io).readyState;
!                     log('state = ' + state);
!                     if (state && state.toLowerCase() == 'uninitialized')
!                         setTimeout(checkState,50);
!                 }
!                 catch(e) {
!                     log('Server abort: ' , e, ' (', e.name, ')');
!                     cb(SERVER_ABORT);
!                     if (timeoutHandle)
!                         clearTimeout(timeoutHandle);
!                     timeoutHandle = undefined;
!                 }
!             }
! 
!             // add "extra" data to form if provided in options
!             var extraInputs = [];
!             try {
!                 if (s.extraData) {
!                     for (var n in s.extraData) {
!                         if (s.extraData.hasOwnProperty(n)) {
!                            // if using the $.param format that allows for multiple values with the same name
!                            if($.isPlainObject(s.extraData[n]) && s.extraData[n].hasOwnProperty('name') && s.extraData[n].hasOwnProperty('value')) {
!                                extraInputs.push(
!                                $('<input type="hidden" name="'+s.extraData[n].name+'">').val(s.extraData[n].value)
!                                    .appendTo(form)[0]);
!                            } else {
!                                extraInputs.push(
!                                $('<input type="hidden" name="'+n+'">').val(s.extraData[n])
!                                    .appendTo(form)[0]);
!                            }
!                         }
!                     }
!                 }
! 
!                 if (!s.iframeTarget) {
!                     // add iframe to doc and submit the form
!                     $io.appendTo('body');
!                     if (io.attachEvent)
!                         io.attachEvent('onload', cb);
!                     else
!                         io.addEventListener('load', cb, false);
!                 }
!                 setTimeout(checkState,15);
! 
!                 try {
!                     form.submit();
!                 } catch(err) {
!                     // just in case form has element with name/id of 'submit'
!                     var submitFn = document.createElement('form').submit;
!                     submitFn.apply(form);
!                 }
!             }
!             finally {
!                 // reset attrs and remove "extra" input elements
!                 form.setAttribute('action',a);
!                 if(t) {
!                     form.setAttribute('target', t);
!                 } else {
!                     $form.removeAttr('target');
!                 }
!                 $(extraInputs).remove();
!             }
!         }
! 
!         if (s.forceSync) {
!             doSubmit();
!         }
!         else {
!             setTimeout(doSubmit, 10); // this lets dom updates render
!         }
! 
!         var data, doc, domCheckCount = 50, callbackProcessed;
! 
!         function cb(e) {
!             if (xhr.aborted || callbackProcessed) {
!                 return;
!             }
!             
!             doc = getDoc(io);
!             if(!doc) {
!                 log('cannot access response document');
!                 e = SERVER_ABORT;
!             }
!             if (e === CLIENT_TIMEOUT_ABORT && xhr) {
!                 xhr.abort('timeout');
!                 deferred.reject(xhr, 'timeout');
!                 return;
!             }
!             else if (e == SERVER_ABORT && xhr) {
!                 xhr.abort('server abort');
!                 deferred.reject(xhr, 'error', 'server abort');
!                 return;
!             }
! 
!             if (!doc || doc.location.href == s.iframeSrc) {
!                 // response not received yet
!                 if (!timedOut)
!                     return;
!             }
!             if (io.detachEvent)
!                 io.detachEvent('onload', cb);
!             else
!                 io.removeEventListener('load', cb, false);
! 
!             var status = 'success', errMsg;
!             try {
!                 if (timedOut) {
!                     throw 'timeout';
!                 }
! 
!                 var isXml = s.dataType == 'xml' || doc.XMLDocument || $.isXMLDoc(doc);
!                 log('isXml='+isXml);
!                 if (!isXml && window.opera && (doc.body === null || !doc.body.innerHTML)) {
!                     if (--domCheckCount) {
!                         // in some browsers (Opera) the iframe DOM is not always traversable when
!                         // the onload callback fires, so we loop a bit to accommodate
!                         log('requeing onLoad callback, DOM not available');
!                         setTimeout(cb, 250);
!                         return;
!                     }
!                     // let this fall through because server response could be an empty document
!                     //log('Could not access iframe DOM after mutiple tries.');
!                     //throw 'DOMException: not available';
!                 }
! 
!                 //log('response detected');
!                 var docRoot = doc.body ? doc.body : doc.documentElement;
!                 xhr.responseText = docRoot ? docRoot.innerHTML : null;
!                 xhr.responseXML = doc.XMLDocument ? doc.XMLDocument : doc;
!                 if (isXml)
!                     s.dataType = 'xml';
!                 xhr.getResponseHeader = function(header){
!                     var headers = {'content-type': s.dataType};
!                     return headers[header];
!                 };
!                 // support for XHR 'status' & 'statusText' emulation :
!                 if (docRoot) {
!                     xhr.status = Number( docRoot.getAttribute('status') ) || xhr.status;
!                     xhr.statusText = docRoot.getAttribute('statusText') || xhr.statusText;
!                 }
! 
!                 var dt = (s.dataType || '').toLowerCase();
!                 var scr = /(json|script|text)/.test(dt);
!                 if (scr || s.textarea) {
!                     // see if user embedded response in textarea
!                     var ta = doc.getElementsByTagName('textarea')[0];
!                     if (ta) {
!                         xhr.responseText = ta.value;
!                         // support for XHR 'status' & 'statusText' emulation :
!                         xhr.status = Number( ta.getAttribute('status') ) || xhr.status;
!                         xhr.statusText = ta.getAttribute('statusText') || xhr.statusText;
!                     }
!                     else if (scr) {
!                         // account for browsers injecting pre around json response
!                         var pre = doc.getElementsByTagName('pre')[0];
!                         var b = doc.getElementsByTagName('body')[0];
!                         if (pre) {
!                             xhr.responseText = pre.textContent ? pre.textContent : pre.innerText;
!                         }
!                         else if (b) {
!                             xhr.responseText = b.textContent ? b.textContent : b.innerText;
!                         }
!                     }
!                 }
!                 else if (dt == 'xml' && !xhr.responseXML && xhr.responseText) {
!                     xhr.responseXML = toXml(xhr.responseText);
!                 }
! 
!                 try {
!                     data = httpData(xhr, dt, s);
!                 }
!                 catch (err) {
!                     status = 'parsererror';
!                     xhr.error = errMsg = (err || status);
!                 }
!             }
!             catch (err) {
!                 log('error caught: ',err);
!                 status = 'error';
!                 xhr.error = errMsg = (err || status);
!             }
! 
!             if (xhr.aborted) {
!                 log('upload aborted');
!                 status = null;
!             }
! 
!             if (xhr.status) { // we've set xhr.status
!                 status = (xhr.status >= 200 && xhr.status < 300 || xhr.status === 304) ? 'success' : 'error';
!             }
! 
!             // ordering of these callbacks/triggers is odd, but that's how $.ajax does it
!             if (status === 'success') {
!                 if (s.success)
!                     s.success.call(s.context, data, 'success', xhr);
!                 deferred.resolve(xhr.responseText, 'success', xhr);
!                 if (g)
!                     $.event.trigger("ajaxSuccess", [xhr, s]);
!             }
!             else if (status) {
!                 if (errMsg === undefined)
!                     errMsg = xhr.statusText;
!                 if (s.error)
!                     s.error.call(s.context, xhr, status, errMsg);
!                 deferred.reject(xhr, 'error', errMsg);
!                 if (g)
!                     $.event.trigger("ajaxError", [xhr, s, errMsg]);
!             }
! 
!             if (g)
!                 $.event.trigger("ajaxComplete", [xhr, s]);
! 
!             if (g && ! --$.active) {
!                 $.event.trigger("ajaxStop");
!             }
! 
!             if (s.complete)
!                 s.complete.call(s.context, xhr, status);
! 
!             callbackProcessed = true;
!             if (s.timeout)
!                 clearTimeout(timeoutHandle);
! 
!             // clean up
!             setTimeout(function() {
!                 if (!s.iframeTarget)
!                     $io.remove();
!                 xhr.responseXML = null;
!             }, 100);
!         }
! 
!         var toXml = $.parseXML || function(s, doc) { // use parseXML if available (jQuery 1.5+)
!             if (window.ActiveXObject) {
!                 doc = new ActiveXObject('Microsoft.XMLDOM');
!                 doc.async = 'false';
!                 doc.loadXML(s);
!             }
!             else {
!                 doc = (new DOMParser()).parseFromString(s, 'text/xml');
!             }
!             return (doc && doc.documentElement && doc.documentElement.nodeName != 'parsererror') ? doc : null;
!         };
!         var parseJSON = $.parseJSON || function(s) {
!             /*jslint evil:true */
!             return window['eval']('(' + s + ')');
!         };
! 
!         var httpData = function( xhr, type, s ) { // mostly lifted from jq1.4.4
! 
!             var ct = xhr.getResponseHeader('content-type') || '',
!                 xml = type === 'xml' || !type && ct.indexOf('xml') >= 0,
!                 data = xml ? xhr.responseXML : xhr.responseText;
! 
!             if (xml && data.documentElement.nodeName === 'parsererror') {
!                 if ($.error)
!                     $.error('parsererror');
!             }
!             if (s && s.dataFilter) {
!                 data = s.dataFilter(data, type);
!             }
!             if (typeof data === 'string') {
!                 if (type === 'json' || !type && ct.indexOf('json') >= 0) {
!                     data = parseJSON(data);
!                 } else if (type === "script" || !type && ct.indexOf("javascript") >= 0) {
!                     $.globalEval(data);
!                 }
!             }
!             return data;
!         };
  
!         return deferred;
!     }
  };
  
  /**
